function [codigos] = huffmanRecursivo(P)

codigos = cell(length(P),1);
if length(P)== 2 %%solo dos elementos, asignamos
    if(P(1)>=P(2))
        codigos{1}=1;
        codigos{2}=0;
    else
        codigos{1}=0;
        codigos{2}=1;
    end
    return;
end

%%si tenemos mas de dos elementos cogemos la pareja menor y la colapsamos
[indicesMenores indicesMayores] = menores(P);
[menores] = sacaIndices(indicesMenores,P);
[mayores] = sacaIndices(indicesMayores,P);

%%construimos una nueva lista de probabilidades con las dos menores sumadas
%%y llamamas a huffman recursivamente
sumaP= [mayores sum(menores)];
codigosSuma = huffmanRecursivo(sumaP);

for i=1:length(mayores)
    codigos{indicesMayores(i)} = codigosSuma{i};
end

codigos{indicesMenores(1)} = [codigosSuma{end} 0];
codigos{indicesMenores(2)} = [codigosSuma{end} 1];

%---------------------------------------------------------
%% FUNCIONES AUXILIARES
%---------------------------------------------------------
%%devuelve la posicion de los dos mayores elementos de P
function [dosMenores, mayores] = menores(P)
   
if(length(P) < 2) 
    disp('Error en mayores(P): P debe tener por lo menos dos elementos');
    return;
end
[ordenados indices] = sort(P);
dosMenores = (indices(1:2));
mayores = (indices(3:end));


%Extrae de una lista P los valores con posiciones indicadas en 'indices'
function [listaValores] = sacaIndices(indices, P)

listaValores=[];
for i=1:length(indices)
    listaValores=[listaValores P(indices(i))];
end

